package kGLModel;

/**
 * float^̒_֘AێAvZׂ̃NX<br>
 * @author kei
 *
 */
public class KGLPoint {
	/**
	 * f[^ێz
	 */
	private float[] data = null ;
	/**
	 * Jf[^쐬
	 * @param in_num	f[^
	 */
	public KGLPoint(int in_num) {
		data = new float[in_num] ;
	}
	/**
	 * wf[^zƓẽf[^ō쐬
	 * @param source	wf[^
	 */
	public KGLPoint(KGLPoint source) {
		data = new float[source.getData().length] ;
		set(source.getData()) ;
	}
	/**
	 * wf[^zƓẽf[^ō쐬
	 * @param in_data	wf[^
	 * @return	쐬NX
	 */
	static public KGLPoint create(KGLPoint in_data) {
		KGLPoint ret ;
		ret = new KGLPoint(in_data.data.length) ;
		ret.set(in_data.getData()) ;
		return ret ;
	}
	/**
	 * wf[^zƓẽf[^ō쐬
	 * @param in_data	wf[^
	 * @return	쐬NX
	 */
	static public KGLPoint create(float[] in_data) {
		KGLPoint ret ;
		ret = new KGLPoint(in_data.length) ;
		ret.set(in_data) ;
		return ret ;
	}
	/**
	 * wtuf[^ł̃NX쐬
	 * @param U	
	 * @param V
	 * @return	쐬NX
	 */
	static public KGLPoint createUV(float U,float V) {
		KGLPoint ret = new KGLPoint(2) ;
		ret.set_UV(U,V) ;
		return ret ;
	}
	/**
	 * w蒸_f[^ł̃NX쐬
	 * @param X
	 * @param Y
	 * @param Z
	 * @return	쐬NX
	 */
	static public KGLPoint createXYZ(float X,float Y,float Z) {
		KGLPoint ret = new KGLPoint(3) ;
		ret.set_XYZ(X,Y,Z) ;
		return ret ;
	}
	/**
	 * wJ[f[^ł̃NX쐬
	 * @param R
	 * @param G
	 * @param B
	 * @return	쐬NX
	 */
	static public KGLPoint createCOLOR(float R,float G,float B) {
		KGLPoint ret = new KGLPoint(3) ;
		ret.set_COLOR(R,G,B) ;
		return ret ;
	}
	/**
	 * wJ[f[^ł̃NX쐬
	 * @param R
	 * @param G
	 * @param B
	 * @param A
	 * @return	쐬NX
	 */
	static public KGLPoint createCOLOR(float R,float G,float B,float A) {
		KGLPoint ret = new KGLPoint(4) ;
		ret.set_COLOR(R,G,B,A) ;
		return ret ;
	}

//	Ki߂āA\ŊĂO`P̒lɂIj
	/**
	 * K<br>
	 * _̋Ƃ߂āASvfŊĂO`P̒lɂ<br>
	 * @return	g	
	 */
	public KGLPoint normalize() {
		double add  ;
		double len ;
		add = 0 ;
		for( int i = 0 ; i < data.length ; i++ ) {
			add += data[i]*data[i] ;
		}
		len = Math.sqrt(add) ;
		if( len == 0 ) return this ;
		for( int i = 0 ; i < data.length ; i++ ) {
			data[i] /= len ;
		}
		return this ;
	}
	/**
	 * fromn_`ton__̓_ɂ<br>
	 * 0      @@from--->to<br>
	 * _<br>
	 *     <br>
	 * 0--->returanl<br>
	 * @param from
	 * @param to
	 * @return	g
	 */
	static public KGLPoint vector(KGLPoint from,KGLPoint to) {
		KGLPoint ret = null ;
		float[] d_from ;
		float[] d_to ;
		float[] d_ret ;
		d_from = from.getData() ;
		d_to = to.getData() ;
		if( d_from.length != d_to.length ) return null ;
		d_ret = new float[d_from.length] ;
		for( int i= 0 ; i < d_ret.length ; i++ ) {
			d_ret[i] = d_to[i] - d_from[i] ;
		}
		ret = new KGLPoint(d_ret.length) ;
		ret.set(d_ret) ;
		return ret ;
	}
	/**
	 * f[^̎o
	 * @return	f[^
	 */
	protected float[] getData() {
		return data ;
	}
	/**
	 * f[^̃NXɐݒ肷
	 * @param src	f[^
	 * @return	g
	 */
	public KGLPoint set(KGLPoint src ) {
		System.arraycopy(src.data,0,data,0,(data.length<src.data.length)?data.length:src.data.length) ;
		return this ;
	}
	/**
	 * f[^̃NXɐݒ肷
	 * @param src	f[^
	 * @return	g
	 */
	public KGLPoint set(float[] src ) {
		System.arraycopy(src,0,data,0,(data.length<src.length)?data.length:src.length) ;
		return this ;
	}
	/**
	 * Rf[^̃NXɐݒ肷
	 * @param x	
	 * @param y
	 * @param z
	 * @return	g
	 */
	public KGLPoint set_XYZ(float x,float y,float z) {
		data[0] = x ;
		data[1] = y ;
		data[2] = z ;
		return this ;
	}
	/**
	 * Qf[^̃NXɐݒ肷
	 * @param u
	 * @param v
	 * @return	g
	 */
	public KGLPoint set_UV(float u,float v) {
		data[0] = u ;
		data[1] = v ;
		return this ;
	}
	/**
	 * J[f[^̃NXɐݒ肷
	 * @param r
	 * @param g
	 * @param b
	 * @return	g
	 */
	public KGLPoint set_COLOR(float r,float g,float b) {
		data[0] = r ;
		data[1] = g ;
		data[2] = b ;
		return this ;
	}
	/**
	 * J[f[^̃NXɐݒ肷
	 * @param r
	 * @param g
	 * @param b
	 * @param a
	 * @return	g
	 */
	public KGLPoint set_COLOR(float r,float g,float b,float a) {
		data[0] = r ;
		data[1] = g ;
		data[2] = b ;
		data[3] = a ;
		return this ;
	}
	/**
	 * ̃NX̗vfɒǉf[^𑫂
	 * @param in	ǉf[^
	 * @return	g
	 */
	public KGLPoint add(KGLPoint in ) {
		for( int i = 0 ; i < in.data.length || i < data.length ; i++ ) {
			data[i] += in.data[i] ;
		}
		return this ;
	}
	/**
	 * ̃NX̗vfɒǉf[^𑫂
	 * @param in	ǉf[^
	 * @return	g
	 */
	public KGLPoint add(float[] in ) {
		for( int i = 0 ; i < in.length || i < data.length ; i++ ) {
			data[i] += in[i] ;
		}
		return this ;
	}
	/**
	 * ̃NX̗vfw{
	 * @param in	{
	 * @return	g
	 */
	public KGLPoint scale(float in) {
		for( int i = 0 ; i < data.length ; i++ ) {
			data[i] *= in ;
		}
		return this ;
	}
	/**
	 * ̃NX̗vfƔrf[^ׂďΔrf[^ɒuivfj
	 * @param in	ǉf[^
	 * @return	g
	 */
	public KGLPoint updateMinimam(KGLPoint in) {
		for( int i = 0 ; i < in.data.length || i < data.length ; i++ ) {
			if( in.data[i] < data[i]) data[i] = in.data[i] ;
		}
		return this ;
	}
	/**
	 * ̃NX̗vfƔrf[^ׂđ傫Δrf[^ɒuivfj
	 * @param in	ǉf[^
	 * @return	g
	 */
	public KGLPoint updateMaximam(KGLPoint in) {
		for( int i = 0 ; i < in.data.length || i < data.length ; i++ ) {
			if( data[i] < in.data[i]) data[i] = in.data[i] ;
		}
		return this ;
	}
	/**
	 * vfo
	 * @return	wf[^
	 */
	public float X() {
		return data[0] ;
	}
	/**
	 * vfxo
	 * @return	wf[^
	 */
	public float Y() {
		return data[1] ;
	}
	/**
	 * vfyo
	 * @return	wf[^
	 */
	public float Z() {
		return data[2] ;
	}
	/**
	 * vfto
	 * @return	wf[^
	 */
	public float U() {
		return data[0] ;
	}
	/**
	 * vfuo
	 * @return	wf[^
	 */
	public float V() {
		return data[1] ;
	}
	/**
	 * vfqo
	 * @return	wf[^
	 */
	public float R() {
		return data[0] ;
	}
	/**
	 * vffo
	 * @return	wf[^
	 */
	public float G() {
		return data[1] ;
	}
	/**
	 * vfao
	 * @return	wf[^
	 */
	public float B() {
		return data[2] ;
	}
	/**
	 * vf`o
	 * @return	wf[^
	 */
	public float A() {
		return data[3] ;
	}
	/**
	 * f[^𕶎ɂ
	 */
	public String toString() {
		String ret = "[" ;
		for( int i = 0 ; i < data.length ; i++ ) {
			ret += Float.toString(data[i]) ;
			if( (i+1)<data.length) ret += ", " ;
		}
		ret += "]";
		
		return ret ;
	}
}
